<?php

/*
cgi-bin/day.php
Copyright 2005 Lorne McIntosh
www.lorneswork.com
*/

require("cgi-bin/db_connect.php");
require("cgi-bin/csscolor.php");

//displays date in the users timezone
function tzDate($date_format, $timestamp)
{ 
	//tz offset is stored in minutes from GMT
	$timestamp += (60 * $_SESSION['tz']); 
    return date($date_format, $timestamp); 
	//using 'date' will adjust 1 hour for daylight saving too, if the SERVER is currently in daylight saving time
	//(this makes DST mandatory for all users, and should really be optional - switch between 'gmdate' and 'date' on a user by user basis?)
}

class day
{
	var $now;

	var $year;
	var $month;
	var $day;
	
	var $then;
	
	function day()
	{
		// get current date for user
		$this->now['year'] = tzDate("Y", time());
		$this->now['mon'] = tzDate("n", time());
		$this->now['mday'] = tzDate("j", time());
		
		// get URL parameters
		if(!isset($_GET['year']))
		{
			$this->year = $this->now["year"]; // if it's null, use default value
		}	
		else
		{
			$this->year = $_GET['year']; // use passed value
		}
		
		if(!isset($_GET['month']))
		{
			$this->month = $this->now["mon"]; // if it's null, use default value
		}
		else
		{
			$this->month = $_GET['month']; // use passed value
		}
		
		if(!isset($_GET['day']))
		{
			$this->day = $this->now["mday"]; // if it's null, use default value
		}
		else
		{
			$this->day = $_GET['day']; // use passed value
		}
		
		// create timestamp for this day
		$this->then = strtotime($this->year . "-" . $this->month . "-" . $this->day);
	}
	
	function dispDate()
	{
		// display the date for the day we're showing
		//Thursday, April 7th 2005
		echo date("l, F jS Y", $this->then);
	}
	
	function dispEvents()
	{
		//get our database objects
		global $db_object;
		global $eventsTable;
		global $attendanceTable;

		//get events from database for this day for this user
		$sql = "SELECT id, owner, title, description, location, DATE_ADD(startDT, INTERVAL '".$_SESSION['tz']."' MINUTE) AS startDT, DATE_ADD(endDT, INTERVAL '".$_SESSION['tz']."' MINUTE) AS endDT, color
			FROM ".$eventsTable."
			RIGHT JOIN ".$attendanceTable." ON id = eid
			WHERE uid = '".$_SESSION['id']."'
			AND (DATE_FORMAT(DATE_ADD(startDT, INTERVAL '".$_SESSION['tz']."' MINUTE), '%Y-%c-%e') = '".$this->year."-".$this->month."-".$this->day."'
			OR DATE_FORMAT(DATE_ADD(endDT, INTERVAL '".$_SESSION['tz']."' MINUTE), '%Y-%c-%e') = '".$this->year."-".$this->month."-".$this->day."')
			ORDER BY startDT
			";
		$query = $db_object->query($sql);
		if (DB::isError($query))
		{
			die($query->getMessage());
		}
		
		if($query->numRows() == 0)
		{
			// no event on this day
			?><div align=center>(There are no events on this day)</div><?php
		}
		else
		{
			// display each event, one at a time
			while ($row = $query->fetchRow())
			{
				if ($row['startDT']) {$start = date("g:ia", strtotime($row['startDT']));}
				if ($row['endDT']) {$end = date("g:ia", strtotime($row['endDT']));}
				$base = new CSS_Color($row['color']);
				
				echo "<table width=\"100%\" border=\"0\" cellpadding=\"4\" cellspacing=\"0\">\n";
				echo "<tr>\n";
				echo "<td width=\"25%\" rowspan=\"2\" valign=\"top\" bgcolor=\"#" . $base->bg['-2'] . "\">\n";
				echo "<font color=\"#" . $base->fg['-2'] . "\"><b>" . $row['title'] . "</b></font></td>\n";
				echo "<td width=\"75%\" valign=\"top\" bgcolor=\"#" . $base->bg['-1'] . "\">\n";
				echo "<font color=\"#" . $base->fg['-1'] . "\">\n";
				if ($row['startDT'])
				{
					echo $start . "\n";
					if ($row['endDT'])
					{
						echo " - " . $end . "\n";
					}
				}
				if($row['location'])
				{
					echo " (" . $row['location'] . ")\n";
				}
				echo "</font></td>\n";
				
				//if this user owns the event, they can edit it - provide event info to the edit script
				if($row['owner'] == $_SESSION['id'])
				{
					//get all users attending this event
					$sql = "SELECT uid
						FROM ".$attendanceTable."
						WHERE eid = '".$row['id']."'
						";
					$usersQuery = $db_object->query($sql);
					if (DB::isError($usersQuery))
					{
						die($usersQuery->getMessage());
					}
					
					//generate hidden form data for users
					$users = "";
					while ($usersRow = $usersQuery->fetchRow())
					{
						$users .= "<input type=\"hidden\" name=\"users[]\" value=\"".$usersRow['uid']."\">\n";
					}

					//we need to translate startDT and endDT into the fields event.php uses
					$startTS = strtotime($row['startDT']);
					$endTS = strtotime($row['endDT']);
					
					//start is an arbitrary choice here - for dates start and end *should be* the same
					$year = date("Y", $startTS);
					$month = date("n", $startTS);
					$day = date("j", $startTS);
					
					$startHour = date("g", $startTS);
					$startMinute = date("i", $startTS);
					$startAMPM = date("A", $startTS);
					
					$endHour = date("g", $endTS);
					$endMinute = date("i", $endTS);
					$endAMPM = date("A", $endTS);
					?>
					<td rowspan="2" valign="top" bgcolor="#<?php echo $base->bg['-1']; ?>">
					<form action="event.php" method="post">
					<input type="hidden" name="id" value="<?php echo $row['id']; ?>">
					<input type="hidden" name="title" value="<?php echo $row['title']; ?>">
					<input type="hidden" name="description" value="<?php echo $row['description']; ?>">
					<input type="hidden" name="location" value="<?php echo $row['location']; ?>">
					
					<input type="hidden" name="year" value="<?php echo $year; ?>">
					<input type="hidden" name="month" value="<?php echo $month; ?>">
					<input type="hidden" name="day" value="<?php echo $day; ?>">
					
					<input type="hidden" name="startHour" value="<?php echo $startHour; ?>">
					<input type="hidden" name="startMinute" value="<?php echo $startMinute; ?>">
					<input type="hidden" name="startAMPM" value="<?php echo $startAMPM; ?>">
					
					<input type="hidden" name="endHour" value="<?php echo $endHour; ?>">
					<input type="hidden" name="endMinute" value="<?php echo $endMinute; ?>">
					<input type="hidden" name="endAMPM" value="<?php echo $endAMPM; ?>">
					
					<input type="hidden" name="color" value="<?php echo $row['color']; ?>">
					
					<?php echo $users; ?>
					
					<input type="hidden" name="edit" value="">
					<input type="image" src="images/icon_edit.png" alt="Edit this event">
					</form>
					</td>
					<?php
				}
				
				?>
				<td rowspan="2" valign="top" bgcolor="#<?php echo $base->bg['-1']; ?>">
				<a style='cursor: pointer; cursor: hand;' onclick='delEvent(<?php echo $row['id']; ?>)'>
				<img src='images/icon_delete.png' alt='Delete this event' border='0'></a></td>
				</tr><tr>
				<td valign="top" bgcolor="#<?php echo $base->bg['+4']; ?>">
				<font color="#<?php echo $base->fg['+4']; ?>">
				<?php
				if($row['description'])
				{
					echo $row['description'] . "\n";
				}
				?>
				</font></td>
				</tr>
				</table>
				<hr>
				<?php
			}
		}
	}
}
?>