<?php

/*
register.php
Copyright 2005 Lorne McIntosh
www.lorneswork.com
*/

require 'cgi-bin/calendar.php';
require 'cgi-bin/formProcessor.php';
require 'cgi-bin/db_connect.php';

if($logged_in == 1)
{
	//already logged in - redirect to index
	header('Location: index.php');
}
else
{
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<title><?php include 'cgi-bin/name.inc.php'; ?> - Create an Account</title>
<link rel="stylesheet" type="text/css" href="shared.css">
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head>
<body onload="document.forms[0].elements[0].focus();">
<table width="100%" height="100%" border="0" align="center"> 
  <tr> 
    <td align="center" valign="middle"> <table width="560" height="240" border="1" align="center" cellpadding="8" cellspacing="0" bordercolor="#000099" bgcolor="#DBEAF5"> 
        <tr align="left" bordercolor="#000099" bgcolor="#DBEAF5"> 
          <td valign="middle" bordercolor="#000099"><strong class="title"><?php include 'cgi-bin/name.inc.php'; ?></strong></td> 
        </tr> 
        <tr align="center" valign="middle" bgcolor="#000099"> 
          <td><font color="#FFFFFF" style="font-weight:bold">Create an Account</font></td> 
        </tr> 
        <tr> 
          <td height="100%" align="right" valign="top">
<?php
$formML = '
<form action="' . $_SERVER['PHP_SELF'] . '" method="post">
<errorlist>
<ul>
<erroritem> <li><message /></li>
</erroritem></ul>
</errorlist>

<p>
<label for="username">Username: </label>
<input type="text" name="username" id="username" compulsory="yes" regexp="|^[a-z0-9]{4,16}$|" callback="checkUsername" maxlength="16" size="20"/>
<error for="username"><strong class="error">!</strong></error>
<errormsg field="username" test="compulsory">You must enter a username</errormsg>
<errormsg field="username" test="regexp">Username must be lowercase, a-z 0-9, and 4-16 characters</errormsg>
<errormsg field="username" test="callback">That username is already taken</errormsg>
</p>

<p>
<label for="email">Email Address: </label>
<input type="text" name="email" id="email" compulsory="yes" regexp="#^([a-zA-Z0-9_\\-\\.]+)@((\\[[0-9]{1,3}\\.[0-9]{1,3}\\.[0-9]{1,3}\\.)|(([a-zA-Z0-9\\-]+\\.)+))([a-zA-Z]{2,4}|[0-9]{1,3})(\\]?)$#" maxlength="100" size="20"/>
<error for="email"><strong class="error">!</strong></error>
<errormsg field="email" test="compulsory">You must enter an email address</errormsg>
<errormsg field="email" test="regexp">The email address you entered is invalid</errormsg>
</p>

<p>
<label for="pass1">Password: </label>
<input type="password" name="pass1" id="pass1" compulsory="yes" regexp="|^[a-z0-9]{6,16}$|" maxlength="16" size="20"/>
<error for="pass1"><strong class="error">!</strong></error>
<errormsg field="pass1" test="compulsory">You must enter a password</errormsg>
<errormsg field="pass1" test="regexp">Password must be lowercase, a-z 0-9, and 6-16 characters</errormsg>
</p>

<p>
<label for="pass2">Re-type Password: </label>
<input type="password" name="pass2" id="pass2" mustmatch="pass1" maxlength="16" size="20"/>
<error for="pass2"> <strong class="error">!</strong></error>
<errormsg field="pass2" test="mustmatch">The password fields did not match</errormsg>
</p>

<p>
<label>Time Zone: </label>
<br/><select name="tz">
<option value="-720">GMT-12:00</option>
<option value="-660">GMT-11:00</option>
<option value="-600">GMT-10:00</option>
<option value="-540">GMT-09:00</option>
<option value="-480">GMT-08:00</option>
<option value="-420">GMT-07:00</option>
<option value="-360">GMT-06:00</option>
<option value="-300">GMT-05:00</option>
<option value="-240">GMT-04:00</option>
<option value="-210">GMT-03:30</option>
<option value="-180">GMT-03:00</option>
<option value="-120">GMT-02:00</option>
<option value="-60">GMT-01:00</option>
<option value="0">GMT</option>
<option value="+60">GMT+01:00</option>
<option value="+120">GMT+02:00</option>
<option value="+180">GMT+03:00</option>
<option value="+210">GMT+03:30</option>
<option value="+240">GMT+04:00</option>
<option value="+270">GMT+04:30</option>
<option value="+300">GMT+05:00</option>
<option value="+330">GMT+05:30</option>
<option value="+345">GMT+05:45</option>
<option value="+360">GMT+06:00</option>
<option value="+390">GMT+06:30</option>
<option value="+420">GMT+07:00</option>
<option value="+480">GMT+08:00</option>
<option value="+540">GMT+09:00</option>
<option value="+570">GMT+09:30</option>
<option value="+600">GMT+10:00</option>
<option value="+660">GMT+11:00</option>
<option value="+720">GMT+12:00</option>
<option value="+780">GMT+13:00</option>
</select>
</p>

<p>
<input type="submit" value="Create Account"/>
</p>
</form>
';

function checkUsername($username)
{
	require 'cgi-bin/db_connect.php';

	$check = $db_object->query("SELECT * FROM " . $usersTable . " WHERE username = '" . $username . "'");
	$db_object->disconnect();
	if (DB::isError($check) || $check->numRows() <= 0)
	{
		//username doesn't exist
		return true;
	}
	else
	{
		//username exists already
		return false;
	}
}

$processor = new FormProcessor($formML);
if ($processor->validate())
{
	// escape input (unless 'magic quotes' has already done it for us)
	if (!get_magic_quotes_gpc())
	{
		$_POST['username'] = addslashes($_POST['username']);
		$_POST['pass1'] = addslashes($_POST['pass1']);
		$_POST['email'] = addslashes($_POST['email']);
		$_POST['tz'] = addslashes($_POST['tz']);
	}

    // now we can add them to the database
	$query = $db_object->query(
		"INSERT INTO " . $usersTable . " () VALUES (
		'',
		'".$_POST['username']."',
		'".$_POST['pass1']."',
		'".gmdate('Y-m-d')."',
		'".$_POST['email']."',
		'".$_POST['tz']."',
		'',
		''
		)");
	$db_object->disconnect();
	if (DB::isError($query))
	{
		die($query->getMessage());
	}
?> 
<h1>Registered</h1> 
<p>Thank you. Your information has been added<br> 
to the database. You may now <a href="login.php">log in</a>.</p> 
<?php
}
else
{
    //show the form
	$processor->display();
}
?> </td> 
        </tr> 
        <tr align="center" valign="middle"> 
          <td><?php include 'cgi-bin/footer.inc.php'; ?></td> 
        </tr> 
      </table></td> 
  </tr> 
</table> 
</body>
</html>
<?php
}
?>